#include <windows.h>
#include <winbase.h>
#include <stdio.h>
#include <direct.h>
#include "resource.h"

// Function Prototypes
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);
int SetupWindows();
int Login();
int BackupLast();
int CopyOver(char Src[MAX_PATH], char Dest[MAX_PATH], int Which);
char* Crypt(char ThePass[10]);

// Globals
HINSTANCE hinst; 
HWND hwndMain; 
HWND hwndBase;
HWND hwndLogin;
HWND hwndPass;
HWND hwndBLogin;
HBITMAP BaseBMP=NULL;
char appName[15] = "LiteStep Login";
char User[10] = "";
char PrevUser[10] = "";
char ini[MAX_PATH] = "";
int LOCK=0;

DWORD MB = MB_OK | MB_SETFOREGROUND;
int ScreenX=0, ScreenY=0;
int Width=400, Height=200;
char LSPath[MAX_PATH] = "c:\\litestep\\";

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, 
    LPSTR lpszCmdLine, int nCmdShow) 
{ 
    MSG msg; 
    WNDCLASS wc; 
    UNREFERENCED_PARAMETER(lpszCmdLine); 
 
	ScreenX = GetSystemMetrics(SM_CXSCREEN);
	ScreenY = GetSystemMetrics(SM_CYSCREEN);
	
    if (!hPrevInstance) 
    {
        wc.style = 0; 
        wc.lpfnWndProc = (WNDPROC) WndProc; 
        wc.cbClsExtra = 0; 
        wc.cbWndExtra = 0; 
        wc.hInstance = hInstance; 
        wc.hIcon = LoadIcon((HINSTANCE) NULL, 
            IDI_APPLICATION); 
        wc.hCursor = LoadCursor((HINSTANCE) NULL, 
            IDC_ARROW); 
        wc.hbrBackground = GetStockObject(WHITE_BRUSH);
        wc.lpszClassName = "LoginMain"; 
 
        if (!RegisterClass(&wc)) 
            return FALSE; 
    } 

    hinst = hInstance;  // save instance handle 
  
    // Create the main window. 

    hwndMain = CreateWindowEx(0, // Extended Styles
							"LoginMain",		// Class
							"LoginMain",		// Name
							WS_POPUP,			// Style
							0, 0,				// Position
							ScreenX, ScreenY,			// W x H
							NULL,			// Parent
							(HMENU) NULL,		// Menu
							hinst,				// Instance
							(LPVOID) NULL);		// Window-creation data
	
    // If the main window cannot be created, terminate 
    // the application. 
 
    if (!hwndMain) 
        return FALSE; 
	
    // Show the window and paint its contents. 
 
	sprintf(ini, "%sUsers\\login.ini", LSPath);
	SetupWindows();
	BaseBMP = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_BITMAP));
	GetProfileString("LiteStep", "Path", "c:\\litestep\\", LSPath, MAX_PATH);
	GetPrivateProfileString("Login", "LastUser", "", PrevUser, 10, ini);
	LOCK = GetPrivateProfileInt("Login", "Lock", 0, ini);
	BackupLast();

    ShowWindow(hwndMain, nCmdShow); 
	ShowWindow(hwndBase, nCmdShow);
	ShowWindow(hwndLogin, nCmdShow);
	ShowWindow(hwndPass, nCmdShow);
	ShowWindow(hwndBLogin, nCmdShow);
    UpdateWindow(hwndMain); 
	UpdateWindow(hwndBase); 
	SetFocus(hwndLogin);

    while (GetMessage(&msg, (HWND) NULL, 0, 0))
    { 
        TranslateMessage(&msg); 
        DispatchMessage(&msg);
		switch (msg.message)
		{
			case WM_KEYDOWN:
			{
				if ((int)msg.wParam == 13)
				{
					if (msg.hwnd == hwndLogin)
						SetFocus(hwndPass);
					if (msg.hwnd == hwndPass)
						SendMessage(hwndBase, (UINT)WM_COMMAND, (WPARAM)BN_CLICKED, (LPARAM)hwndBLogin);
				}
			}
		}
    } 
 
    // Return the exit code to the system. 
 
    return msg.wParam; 
} 

LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    switch (message)
    {
		case WM_CREATE:		return 0;
        case WM_ERASEBKGND: return 0;
        case WM_PAINT:
		{ 
			PAINTSTRUCT ps;
			HDC hdc = BeginPaint(hwnd,&ps);
			RECT r;
			GetClientRect(hwnd, &r);
			if (hwnd == hwndBase)
			{
				HDC buf = CreateCompatibleDC(NULL);
				HDC bufBMP = CreateCompatibleBitmap(hdc, Width, Height);
				HBRUSH hbr = CreateSolidBrush(0x00FFFFFF);

				FillRect(hdc, &r, hbr);
				SelectObject(buf, BaseBMP);
				BitBlt(hdc, 0, 0, Width, Height, buf, 0, 0, SRCCOPY);
				EndPaint(hwnd,&ps);
				DeleteObject(hbr);
				DeleteDC(buf);
				DeleteObject(bufBMP);
			}
			else EndPaint(hwnd,&ps);
		}
		return 0;
		case WM_COMMAND:
		{
			switch (wParam)
			{
				case BN_CLICKED:
				{
					if ((HWND)lParam == hwndBLogin)
					{
						int Result=0;
						Result = Login();
						if (Result)
						{
							// Login exited with 1
							// Good Scenario
							char temp[25] = "";
							WritePrivateProfileString("Login", "LastUser", User, ini);
							sprintf(temp, "%slitestep.exe", LSPath);
							WinExec(temp, SW_SHOWNORMAL);
							exit(0);
						}
					}
					break;
				}
			}
		}
		return 0;
		case WM_SYSCOMMAND:
		{
			switch (wParam)
			{
			case SC_CLOSE:
				return 0;
			}
		}
    }
    return DefWindowProc(hwnd,message,wParam,lParam);
}

int SetupWindows()
{
	WNDCLASS wc;
	wc.style = 0; 
	wc.lpfnWndProc = (WNDPROC) WndProc; 
	wc.cbClsExtra = 0; 
	wc.cbWndExtra = 0; 
	wc.hInstance = hinst; 
	wc.hIcon = LoadIcon((HINSTANCE) NULL, 
						IDI_APPLICATION); 
	wc.hCursor = LoadCursor((HINSTANCE) NULL, 
							IDC_ARROW); 
	wc.hbrBackground = GetStockObject(WHITE_BRUSH);
	wc.lpszClassName = "Base"; 
	
	if (!RegisterClass(&wc)) 
		return FALSE; 
    
	hwndBase = CreateWindowEx(0,
							"Base",
							"Base",
							WS_CHILD | WS_BORDER,
							ScreenX/2 - 200, ScreenY/2 - 100,
							Width, Height,
							hwndMain,
							(HMENU) NULL,
							hinst,
							(LPVOID) NULL);

	if (!hwndBase) 
        return FALSE; 

	hwndLogin = CreateWindowEx(0,
							"Edit",
							"",
							WS_CHILD | WS_BORDER,
							14, 86,
							244, 32,
							hwndBase,
							(HMENU) NULL,
							hinst,
							(LPVOID) NULL);
	
	if (!hwndLogin) 
        return FALSE;

	{
		HFONT font = CreateFont(28, 0, 0, 0, 0, FALSE, FALSE, FALSE,
							ANSI_CHARSET, 0, 0, 0, 0, "Console");
		SendMessage(hwndLogin, WM_SETFONT, (WPARAM)font, MAKELPARAM(TRUE,0));
	}

	hwndPass = CreateWindowEx(0,
							"Edit",
							"",
							WS_CHILD | WS_BORDER | ES_PASSWORD,
							14, 160,
							244, 32,
							hwndBase,
							(HMENU) NULL,
							hinst,
							(LPVOID) NULL);

	if (!hwndPass) 
        return FALSE; 

	{
		HFONT font = CreateFont(28, 0, 0, 0, 0, FALSE, FALSE, FALSE,
							ANSI_CHARSET, 0, 0, 0, 0, "Console");
		SendMessage(hwndPass, WM_SETFONT, (WPARAM)font, MAKELPARAM(TRUE,0));
	}

	hwndBLogin = CreateWindowEx(0,
							"Button",
							"Login",
							WS_CHILD | BS_PUSHBUTTON,
							285, 160,
							100, 32,
							hwndBase,
							(HMENU) NULL,
							hinst,
							(LPVOID) NULL);

	if (!hwndBLogin) 
        return FALSE;

	return 1;
}

int Login()
{
	char Pass[10] = "";
	char ThePass[10] = "";
	char Src[MAX_PATH] = "";
	char Dest[MAX_PATH] = "";
	char temp[256] = "";

	GetWindowText(hwndLogin, User, 10);
	GetWindowText(hwndPass, Pass, 10);
	GetPrivateProfileString("Login", User, "No User", ThePass, 10, ini);
	Crypt(Pass);

	if (!strnicmp(ThePass, "No User", 7))
	{
		if (!LOCK)
		{
			// New User
			int Result=0;
			sprintf(temp, "User Not Found.\n\nWould you like to add %s as a new user?\n", User);
			Result = MessageBox(NULL, temp, appName, MB_YESNO | MB_SETFOREGROUND | MB_ICONQUESTION); 
			
			if (Result == IDYES)
			{
				// Check to see if Users dir exists
				sprintf(temp, "%sUsers", LSPath);
				if (CreateDirectory(temp, NULL))
				{
					sprintf(Src, "%sStep.rc", LSPath);
					sprintf(Dest, "%sUsers\\Step.rc", LSPath);
					if (!CopyOver(Src, Dest, 0))
					{
						MessageBox(NULL, "Could not copy step.rc", appName, MB);
						return 0;
					}

					sprintf(Src, "%sModules.ini", LSPath);
					sprintf(Dest, "%sUsers\\Modules.ini", LSPath);
					if (!CopyOver(Src, Dest, 0))
					{
						MessageBox(NULL, "Could not copy modules.ini", appName, MB);
						return 0;
					}
					
					sprintf(Src, "%sLogin.reg", LSPath);
					sprintf(Dest, "%sUsers\\Login.reg", LSPath);
					if (!CopyOver(Src, Dest, 0))
					{
						MessageBox(NULL, "Could not copy Login.reg", appName, MB);
						return 0;
					}
				}

				// Add The User
				sprintf(Dest, "%sUsers\\%s", LSPath, User);
				if (CreateDirectory(Dest, NULL))
				{
					sprintf(Src, "%sUsers\\Step.rc", LSPath);
					sprintf(Dest, "%sUsers\\%s\\Step.rc", LSPath, User);
					if (!CopyOver(Src, Dest, 0))
					{
						MessageBox(NULL, "User Not Added.\n\nDefault source files not found", appName, MB);
						return 0;
					}
					
					sprintf(Src, "%sUsers\\Modules.ini", LSPath);
					sprintf(Dest, "%sUsers\\%s\\Modules.ini", LSPath, User);
					if (!CopyOver(Src, Dest, 0))
					{
						MessageBox(NULL, "User Not Added.\n\nDefault source files not found", appName, MB);
						return 0;
					}
					
					sprintf(Src, "%sUsers\\Login.reg", LSPath);
					sprintf(Dest, "%sUsers\\%s\\Login.reg", LSPath, User);
					if (!CopyOver(Src, Dest, 0))
					{
						MessageBox(NULL, "User Not Added.\n\nDefault source files not found", appName, MB);
						return 0;
					}
					WritePrivateProfileString("Login", User, Pass, ini);
				}
				else
				{
					MessageBox(NULL, "User Not Added.\n\nError creating User Directory.", appName, MB);
					return 0;
				}
			}
			else
			{
				return 0;
			}
		}
		else
		{
			MessageBox(NULL, "Sorry, the lock has been activated. No more users may be added at this time.", appName, MB);
			return 0;
		}
		return 1;
	}
	else
	{
		// Check the Login and Password
		if (strnicmp(ThePass, Pass, 10))
		{
			// Incorrect
			MessageBox(NULL, "Login Incorrect", appName, MB | MB_ICONEXCLAMATION);
			return 0;
		}
		else
		{
			// Correct. Try to copy files
			sprintf(Src, "%sUsers\\%s\\Step.rc", LSPath, User);
			sprintf(Dest, "%s\\Step.rc", LSPath);
			if (!CopyOver(Src, Dest, 0))
				return 0;
			sprintf(Src, "%sUsers\\%s\\Modules.ini", LSPath, User);
			sprintf(Dest, "%sModules.ini", LSPath);
			if (!CopyOver(Src, Dest, 0))
				return 0;
			sprintf(Src, "regedit -s %sUsers\\%s\\Login.reg", LSPath, User);
			WinExec(Src, SW_SHOWNORMAL);
			SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, NULL, 0);
		}
	}
	return 1;
}

int CopyOver(char Src[MAX_PATH], char Dest[MAX_PATH], int Which)
{
	BOOL RESULT=FALSE;
	RESULT = CopyFile(Src, Dest, FALSE);
	
	if (!RESULT && !Which)
	{
		DWORD FAIL = GetLastError();
		if (FAIL == ERROR_PATH_NOT_FOUND)
		{
			MessageBox(NULL, "User Directory/Files Not Found.\n", appName, MB | MB_ICONEXCLAMATION);
		}
		else
		{
			LPVOID lpMsgBuf;
			FormatMessage( FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
				NULL, 
				FAIL,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT),
				(LPTSTR) &lpMsgBuf,
				0,
				NULL );

			MessageBox( NULL, lpMsgBuf, appName, MB_OK | MB_ICONEXCLAMATION );
			LocalFree( lpMsgBuf );
		}
		return 0;
	}
	return 1;

}

char* Crypt(char Pass[10])
{
	int key = 0x5405;
	int i=0;
	char crypt[10] = "";

	for (i = 0; i < strlen(Pass); i++) 
		Pass[i] = Pass[i] ^ key;

	return Pass;
}

int BackupLast()
{
	char temp[10] = "";
	char Src[MAX_PATH] = "";
	char Dest[MAX_PATH] = "";

	sprintf(Src, "%sStep.rc", LSPath);
	sprintf(Dest, "%sUsers\\%s\\Step.rc", LSPath, PrevUser);
	CopyOver(Src, Dest, 1);
	sprintf(Src, "%sModules.ini", LSPath);
	sprintf(Dest, "%sUsers\\%s\\Modules.ini", LSPath, PrevUser);
	CopyOver(Src, Dest, 1);

	return 1;
}